// ==UserScript==
// @name Advanced tooltips
// @author Lex1
// @version 0.5
// @include *
// ==/UserScript==

(function(){
var filter=/\.(?:exe|com|dll|bin|scr|msi|dmg|7z|zip|rar|arj|ace|lzh|xpi|iso|gz|gzip|tgz|bz2|tar|rpm|deb|avi|mpeg|mpg|mp4|wmv|asf|mov|rv|mp3|flac|ape|wma|ra|ram|qt|ogg|doc|pdf|rtf|xls|ppt|chm|djvu)$/i;

document.addEventListener('mouseover', function(e){var hl=e.target;
	if(hl && hl.nodeName != 'IMG')while(hl.nodeName != 'A' && hl.parentNode){hl=hl.parentNode};
	if(!hl || !hl.href || hl.title.indexOf('Size: ') != -1 || hl.title.indexOf('Date: ') != -1)return;
	if(hl.title.indexOf('Address: ')!=0)hl.title='Address: '+hl.href;

	if(hl.protocol == 'http:' && location.hostname == hl.hostname && filter.test(hl.href)){
		var req=new XMLHttpRequest();
		req.open('HEAD', hl.href, true);
		req.onload = function () {
			if (this.readyState == 4){
				var d=this.getResponseHeader('Last-modified');
				var s=(function(sz){
						if( !sz || isNaN(sz=parseInt(sz)) ) return '';
						if(sz<1024)return sz+' B';
						else if(sz<1024*1024)return (sz/1024|0)+' KB';
						else if(sz<1024*1024*1024)return (sz/1024/1024|0)+' MB';
						else if(sz<1024*1024*1024*1024)return (sz/1024/1024/1024|0)+' GB';
					})(this.getResponseHeader('Content-Length'));
					var inf=(s ? 'Size: '+s+'; ' : '')+(d ? 'Date: '+new Date(d).toLocaleString() : '');
					if(inf)hl.title=(hl.title ? hl.title+'; ' : '')+inf;
			}
		};
		req.send(null);}
}, false)
})();
